
require("audioin")
audioin.helloworld() 


function sprintf(...) return string.format(...) end
local min = math.min
local max = math.max

local num_samples_record
local num_samples_fft
local sample_rate
audioin.Init(num_samples_record or 2048,num_samples_fft or 2048,sample_rate or 44100)
local t2 = {}

function PrintAsciDiagram (t,w,h) 
	w = w or 80
	h = h or 10
	local row = {}
	for y=1,h do 
		local celval = (h-y)*1/h
		for x=1,w do row[x] = ((t[x] or 0) >= celval) and "#" or "." end
		print(table.concat(row,""))
	end
end

while (true) do 
	--~ audioin.AsciSpectroStep()
	audioin.Sleep()
	
	local expandfactor
	local numsamples = 80
	local t = audioin.ExecuteFFT(expandfactor or 1,numsamples or num_samples_fft)
	local mi = t[1]
	local ma = t[1]
	for i=1,numsamples do
		local v = t[i]
		--~ if (not v) then print("fft: missing value:",i) end
		--~ v = math.log10(v)
		t2[i] = v * 2 / 4
		mi = min(mi,v)
		ma = max(ma,v)
	end
	print(sprintf("%9.4f..%9.4f",mi,ma))
	PrintAsciDiagram(t2)
		
	--~ print(unpack(t))
end
audioin.Quit() 

